//-------------------------------------------------------------------------------
//      ＰＳｏＣ　８×２　ＬＣＤ表示プログラム  Ver1.01
//      ACM0802C-NLW-BBH
//
//                                              Software design    : Masaru Osuga
//                                                         DATE    :  2009/10/18 
//
// Reorganization history--------------------------------------------------------
// Ver1.01		2009/10/18		Update PD5.0SP6 ImageCraft Cに変更
// Ver1.00		2009/03/09		New Software release.            
//-------------------------------------------------------------------------------
//
//	[Connect IO]
//	LCD			  Port2			ユーザーモジュールにて設定
//	LCD_Vo		  Port0[2]		ＬＣＤコントラストの調整
//
//-------------------------------------------------------------------------------

#include <m8c.h>
#include <stdio.h>
#include <string.h>
#include "PSoCAPI.h"
#include "font_pack.h"

BYTE count = 0;
BYTE Vreg_A_Cap;


void wait(long l){ while(l--); }
int putchar(char c)
{
	char	str[]=" ";
	strncpy(str,&c,1);
	LCD_PrString(str);
	return c;
}
void pos(char x,char y)
{
	LCD_Position(x,y);
}
void LCD_DispCLS(void)
{
	pos(0,0);
    cprintf("        ");
	pos(1,0);
	cprintf("        ");
}

void LCD_DispDemo1(void)
{	
	int i;
	BOOL flag = 1;
	Vreg_A_Cap = 5;
	
	LCD_DispCLS();
	pos(0,0);
    cprintf(" PSoC 1 ");
	pos(1,0);
	cprintf("LCD DEMO");
	for(i=0;i<100;i++){
		if(flag){
			if((++Vreg_A_Cap)>30)flag = 0;
		}
		else{
			if((--Vreg_A_Cap)< 5)flag = 1;
		}
		Vreg_cr0 = 0b10100000 + Vreg_A_Cap;
		wait(8000);
	}
}

void LCD_DispDemo2(void)
{
	int i;
BYTE FullDot[] = { 0xff ,0xff ,0xff ,0xff ,0xff ,0xff ,0xff ,0xff , NULL };
	LCD_DispCLS();
	Vreg_cr0 = 0b10100000 + 30;
	wait(30000L);
		pos(0,0);
    	cprintf(" PSoC 1 ");
		pos(1,0);
		cprintf("LCD DEMO");
		wait(40000L);
	for(i=0;i<6;i++){
		pos(0,0);
		printf(FullDot);
		pos(1,0);
		printf(FullDot);
		wait(12000L);
		pos(0,0);
    	cprintf(" PSoC 1 ");
		pos(1,0);
		cprintf("LCD DEMO");
		wait(40000L);
	}
	Vreg_cr0 = 0b10100000 + 5;
	wait(30000L);
}

void LCD_DispDemo3(void)
{
	int i;
BYTE Ichimatu1[] = { 0xff ,0x10 ,0xff ,0x10 ,0xff ,0x10 ,0xff ,0x10 , NULL };
BYTE Ichimatu2[] = { 0x10 ,0xff ,0x10 ,0xff ,0x10 ,0xff ,0x10 ,0xff , NULL };

	LCD_DispCLS();
	Vreg_cr0 = 0b10100000 + 30;
	wait(30000L);
	for(i=0;i<7;i++){
		pos(0,0);
		printf(Ichimatu1);
		pos(1,0);
		printf(Ichimatu2);
		wait(40000L);
		pos(0,0);
		printf(Ichimatu2);
		pos(1,0);
		printf(Ichimatu1);
		wait(40000L);
	}
	Vreg_cr0 = 0b10100000 + 5;
	wait(30000L);
}

void LCD_DispDemo4(void)
{
	int i;
BYTE userRAM[] = { 0x08 ,0x09 ,0x0a ,0x0b ,0x0c ,0x0d ,0x0e ,0x0f ,NULL };
	BOOL flag = 1;
	char temp;
	char loop;
	
	Vreg_A_Cap = 5;
	
	
	LCD_Control(0b01000000);
	
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData00[temp]);
	}
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData01[temp]);
	}
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData02[temp]);
	}
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData03[temp]);
	}
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData04[temp]);
	}
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData05[temp]);
	}
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData06[temp]);
	}
	for (temp=0;temp<8;temp++){
		LCD_WriteData(UserData07[temp]);
	}
	Vreg_cr0 = 0b10100000 + 21;
	pos(0,0);
	printf(userRAM);
	pos(1,0);
	cprintf("01:00:30");
	
	
	for(i=0;i<100;i++){
		if(flag){
			if((++Vreg_A_Cap)>30)flag = 0;
		}
		else{
			if((--Vreg_A_Cap)< 5)flag = 1;
		}
		Vreg_cr0 = 0b10100000 + Vreg_A_Cap;
		wait(10000L);
	}
}


void main(void)
{
	Vreg_cr0 = 0b10100000 + Vreg_A_Cap;
	Vreg_Start(3);
	LCD_Start();
	
	while(1){
		LCD_DispDemo1();
		wait(100000L);
		LCD_DispDemo2();
		wait(100000L);
		LCD_DispDemo3();
		wait(100000L);
		LCD_DispDemo4();
		wait(100000L);
		LCD_DispCLS();
	}
}
